using Exferia_Aplicacion.Calculos;
using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Ventas._0_Modelos;
using Exferia_Ventas.General;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;
using System.Linq;
using Exferia_Ventas._3_Vistas.Controladoras;
using Exferia_Aplicacion.Calculos.VentasCompras;

namespace Exferia_Ventas._3_Vistas
{
    public partial class P_AlbaranLinea_Trazabilidad : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        private P_AlbaranLinea_Trazabilidad_Controladora g_obj_Controladora;
        private int g_int_CentroInformacion_Ancho = 150;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador......................................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();
        #endregion

        #region Objetos en Pantalla
        // Exferia_ArbolSecundarioSeleccion
        internal Exferia_ArbolSecundarioSeleccion Exferia_ArbolSecundarioSeleccion_AlbaranLinea_Trazabilidad { get { return ex_trv_P_AlbaranLinea_Trazabilidad_ArbolSecundarioSeleccion; } }

        // Exferia_Label
        internal Exferia_Label Exferia_Label_Cantidad { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_Cantidad; } }
        internal Exferia_Label Exferia_Label_SegundaUnidad { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_SegundaUnidad; } }

        // Exferia_Label_SinColor
        internal Exferia_Label_SinColor Exferia_Label_SinColor_Resumen { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_Resumen; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_Articulo { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_Articulo; } }

        internal Exferia_Label_SinColor Exferia_Label_SinColor_TipoEmbalaje_Valor { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_TipoEmbalaje_Valor; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_MovimientoPrincipal_Valor { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_MovimientoPrincipal_Valor; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_TrazadoPrincipal_Valor { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_TrazadoPrincipal_Valor; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_DiferenciaPrincipal_Valor { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_DiferenciaPrincipal_Valor; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_TipoEmbalajeRelacionado_Valor { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_TipoEmbalajeRelacionado_Valor; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_MovimientoRelacionado_Valor { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_MovimientoRelacionado_Valor; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_TrazadoRelacionado_Valor { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_TrazadoRelacionado_Valor; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_DiferenciaRelacionado_Valor { get { return ex_lbl_P_AlbaranLinea_Trazabilidad_DiferenciaRelacionado_Valor; } }

        // Exferia_F3_SoloSeleccion_Simple
        internal Exferia_F3_SoloSeleccion_Simple Exferia_F3_SoloSeleccion_Simple_ArticuloTrazabilidad { get { return ex_usc_F3_P_AlbaranLinea_Trazabilidad_ArticuloTrazabilidad; } }

        // Panel
        internal Panel Panel_SegundaUnidad { get { return pnl_SegundaUnidad; } }

        // Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Cantidad { get { return ex_txt_P_AlbaranLinea_Trazabilidad_Cantidad; } }
        internal Exferia_TextBox Exferia_TextBox_SegundaUnidad { get { return ex_txt_P_AlbaranLinea_Trazabilidad_SegundaUnidad; } }
        internal Exferia_TextBox Exferia_TextBox_Observaciones { get { return ex_txt_P_AlbaranLinea_Trazabilidad_Observaciones; } }

        // Exferia_FechaSeleccion
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaCaducidad { get { return ex_usc_P_AlbaranLinea_Trazabilidad_FechaCaducidad; } }

        // Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_AlbaranLinea_Trazabilidad { get { return ex_Paginador; } }
        #endregion

        #region Constructor
        public P_AlbaranLinea_Trazabilidad(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo,
                                                     DateTime _dtt_FechaTrabajo,
                                                     PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle,
                                                     INTERNO_VTA_AlbaranesCabecera_Modelo _mdl_INTERNO_VTA_AlbaranesCabecera_Modelo,
                                                     INTERNO_VTA_AlbaranesFacturasLineas_Modelo _mdl_INTERNO_VTA_AlbaranesFacturasLineas_Modelo,
                                                     List<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo> _lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo,
                                                     G_ENUM_VALIDACIONFECHAS_TIPOCIERRE _obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE,
                                                     string _str_Estado,
                                                     bool _bol_EsLineaArticuloEnPromocion)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instanciar Controladora
                g_obj_Controladora = new P_AlbaranLinea_Trazabilidad_Controladora(this, _mdl_INTERNO_VTA_AlbaranesCabecera_Modelo, _mdl_INTERNO_VTA_AlbaranesFacturasLineas_Modelo, _lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo, _bol_EsLineaArticuloEnPromocion);

                //Tipo de Cierre Actual
                g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE = _obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE;
                g_obj_Controladora.g_str_Estado = _str_Estado;

                //Ejercicio Actual
                g_obj_Controladora.g_mdl_GEN_EjerciciosActivos_Empresa = Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO.EjercicioActivo;

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los Botones que no se Spueden poner bloqueados o de solo lectura
                ex_btn_P_AlbaranLinea_Trazabilidad_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_AlbaranLinea_Trazabilidad_Grabar.Exferia_Button_Bloqueable = false;

                ex_btn_P_AlbaranLinea_Trazabilidad_ArbolSecundarioSeleccion_MostrarOcultar.Exferia_Button_Bloqueable = false;

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla .............................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //centro informacion
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(nameof(P_AlbaranLinea_Trazabilidad)))
                    {
                        g_int_CentroInformacion_Ancho = Variables.G_DCT_CONFIGURACIONPANTALLA[nameof(P_AlbaranLinea_Trazabilidad)].CENTROINFORMACION_Ancho;
                    }
                }

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_AlbaranLinea_Trazabilidad) + "/" + nameof(P_AlbaranLinea_Trazabilidad));
                    }
                }
                //....................................................................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

                //Rellenar para los F3 .......................................
                //Articulo_Trazabilidad
                ex_usc_F3_P_AlbaranLinea_Trazabilidad_ArticuloTrazabilidad.Exferia_F3_SoloSeleccion_Simple_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_ARTICULOS_TRAZABILIDAD;
                ex_usc_F3_P_AlbaranLinea_Trazabilidad_ArticuloTrazabilidad.Exferia_F3_SoloSeleccion_Simple_PantallaContenedora = this;
                ex_usc_F3_P_AlbaranLinea_Trazabilidad_ArticuloTrazabilidad.Exferia_F3_SoloSeleccion_Simple_PRINCIPAL_BUSCARTITULO = false;

                List<INTERNO_Filtro_OpcionPadre_Modelo> lst_Filtro_OpcionPadre_Modelo = new List<INTERNO_Filtro_OpcionPadre_Modelo>();

                //Articulo
                lst_Filtro_OpcionPadre_Modelo.Add(new INTERNO_Filtro_OpcionPadre_Modelo(Variables.G_STR_OPCION_MAE_ARTICULO, g_obj_Controladora.g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Modelo.idArticulo.Value));
                lst_Filtro_OpcionPadre_Modelo.Add(new INTERNO_Filtro_OpcionPadre_Modelo(nameof(MAE_Articulos_Trazabilidad.tieneStock),-1, true));

                ex_usc_F3_P_AlbaranLinea_Trazabilidad_ArticuloTrazabilidad.Exferia_F3_SoloSeleccion_Simple_RELACIONADOS = lst_Filtro_OpcionPadre_Modelo;


                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_AlbaranLinea_Trazabilidad) + "/" + nameof(P_AlbaranLinea_Trazabilidad));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }
        }
        #endregion

        #region Inicio de pantalla
        private void P_AlbaranLinea_Trazabilidad_Load(object sender, EventArgs e)
        {
            try
            {
                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }
                };
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_AlbaranLinea_Trazabilidad) + "/" + nameof(P_AlbaranLinea_Trazabilidad_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }
        private void P_AlbaranLinea_Trazabilidad_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {

                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        ActivarBotones(false);

                        //Poner Texto predeterminado y foco
                        Funciones.Poner_Foco_Objeto(this, ex_usc_F3_P_AlbaranLinea_Trazabilidad_ArticuloTrazabilidad.Exferia_F3_SoloSeleccion_Simple_PRINCIPAL_TextBox_Codigo);

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;

                    }
                    // Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados_AUX1 != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados_AUX1.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados_AUX1.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_AlbaranLinea_Trazabilidad.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_AlbaranLinea_Trazabilidad.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_AlbaranLinea_Trazabilidad) + "/" + nameof(P_AlbaranLinea_Trazabilidad_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        private void P_AlbaranLinea_Trazabilidad_Enter(object sender, EventArgs e)
        {
            try
            {
                this.Activate();
            }
            catch (Exception)
            { }
        }

        public void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_AlbaranLinea_Trazabilidad.Visible)
            {
                Exferia_Paginador_AlbaranLinea_Trazabilidad.Visible = _bol_Activar;
            }

            if (ex_btn_P_AlbaranLinea_Trazabilidad_Borrar.Enabled)
            {
                ex_btn_P_AlbaranLinea_Trazabilidad_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Botones Grabar, Borrar 

        private void ex_btn_P_AlbaranLinea_Trazabilidad_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreAdministrativo))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERREADMINISTRATIVO());
            }
            else if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreContable))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERRECONTABLE());
            }
            else
            {
                if (//Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
                {
                    //Si el Documento esta cerrado no puedo grabar
                    if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                    }
                    else
                    {
                        //Añadiendo
                        if (this.P_Base_TipoAperturaPantalla == 0)
                        {
                            g_obj_Controladora.GrabarDatos(true);
                        }
                        //Modificando
                        else
                        {
                            g_obj_Controladora.GrabarDatos(false);
                        }
                    }
                }
            }
        }

        private void ex_btn_P_AlbaranLinea_Trazabilidad_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreAdministrativo))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERREADMINISTRATIVO());
            }
            else if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreContable))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERRECONTABLE());
            }
            else
            {
                if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
                {
                    //Si el Documento esta cerrado no puedo borrar
                    if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                    }
                    else
                    {
                        g_obj_Controladora.BorrarDatos();
                    }
                }
            }
        }
        #endregion

        #region Arbol Secundario Seleccion
        private void ex_btn_P_AlbaranLinea_Trazabilidad_ArbolSecundarioSeleccion_MostrarOcultar_Click(object sender, EventArgs e)
        {
            if (spl_P_AlbaranLinea_Trazabilidad_Principal.Panel2Collapsed)
            {
                spl_P_AlbaranLinea_Trazabilidad_Principal.Panel2Collapsed = false;
            }
            else
            {
                spl_P_AlbaranLinea_Trazabilidad_Principal.Panel2Collapsed = true;
            }
        }
        private void ex_trv_P_AlbaranLinea_Trazabilidad_ArbolSecundarioSeleccion_Exferia_ArbolSecundarioSeleccion_NodoSeleccion(object sender, EventArgs e)
        {
            spl_P_AlbaranLinea_Trazabilidad_Principal.Panel2Collapsed = true;
        }
        #endregion

        #region Controles Enventos
        private void ex_txt_P_AlbaranLinea_Trazabilidad_Cantidad_Exferia_TextBox_Evento_TextChanged(object sender, EventArgs e)
        {
            if (g_obj_Controladora != null &&
                g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial &&
                g_obj_Controladora.g_bol_CargarDatos_Termino)
            {
                Controlar_Modificaciones();
            }
        }
        private void ex_txt_P_AlbaranLinea_Trazabilidad_Cantidad_Exferia_TextBox_Evento_LostFocus(object sender, EventArgs e)
        {
            //Si la trazabilidad no ha sido añadida a base de datos y tiene Tipo embalaje relacional, 
            // se calcula automaticamente la cantidad relacional, por la relacion de cantidades que hay en el articulo
            if (g_obj_Controladora.g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Modelo == null &&
                pnl_SegundaUnidad.Visible)
            {
                Calculos_FuncionesGenerales.Calcular_SegundaUnidad(ex_txt_P_AlbaranLinea_Trazabilidad_Cantidad, ex_txt_P_AlbaranLinea_Trazabilidad_SegundaUnidad, g_obj_Controladora.g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Modelo.segundaUnidad_cantidad != null ? g_obj_Controladora.g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Modelo.segundaUnidad_cantidad.Value : 0);
            }
        }

        private void ex_txt_P_AlbaranLinea_Trazabilidad_SegundaUnidad_Exferia_TextBox_Evento_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }
        private void ex_usc_F3_P_AlbaranLinea_Trazabilidad_ArticuloTrazabilidad_Exferia_F3_SoloSeleccion_Simple_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            try
            {
                Controlar_Modificaciones();

                g_obj_Controladora.g_mdl_MAE_Articulos_Trazabilidad = null;

                if (ex_usc_F3_P_AlbaranLinea_Trazabilidad_ArticuloTrazabilidad.Exferia_F3_SoloSeleccion_Simple_Id > -1)
                {
                    g_obj_Controladora.RecargarDatos_TrazabilidadArticulo_Seleccionado(ex_usc_F3_P_AlbaranLinea_Trazabilidad_ArticuloTrazabilidad.Exferia_F3_SoloSeleccion_Simple_Id);
                }

                g_obj_Controladora.ArbolSecundario_Cambiar_ClienteArticuloTrazabilidad(g_obj_Controladora.g_mdl_INTERNO_VTA_AlbaranesCabecera_Modelo.idCliente.Value);
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_AlbaranLinea_Trazabilidad) + "/" + nameof(ex_usc_F3_P_AlbaranLinea_Trazabilidad_ArticuloTrazabilidad_Exferia_F3_SoloSeleccion_Simple_Evento_TerminoBusqueda));
            }
        }
        #endregion

        #region Controlar si se modifica algo

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }

        #endregion

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_AlbaranLinea_Trazabilidad.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_AlbaranLinea_Trazabilidad.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_AlbaranLinea_Trazabilidad.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_AlbaranLinea_Trazabilidad.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
                {
                    // Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_AlbaranLinea_Trazabilidad.txt_ValorPaginaActual - 1);

                    // Asignando al control la pagina actual.
                    Exferia_Paginador_AlbaranLinea_Trazabilidad.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();

                    g_obj_Controladora.RecargarDatos();
                }
            }
        }

        #endregion

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }


        #endregion

        #region Cierre de Pantalla
        private void P_AlbaranLinea_Trazabilidad_FormClosed(object sender, FormClosedEventArgs e)
        {
            try
            {
                #region DATOS DEL MANTENIMIENTO
                //Guardar el fichero xml de configuracion de la pantalla
                INTERNO_ConfiguracionPantalla_Modelo mdl_INTERNO_ConfiguracionPantalla_Modelo = new INTERNO_ConfiguracionPantalla_Modelo();

                //Centro de Informacion Ancho
                mdl_INTERNO_ConfiguracionPantalla_Modelo.CENTROINFORMACION_Ancho = g_int_CentroInformacion_Ancho;

                //Actualizar la Variables General
                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //Ver si ya existia
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(nameof(P_AlbaranLinea_Trazabilidad)))
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA[nameof(P_AlbaranLinea_Trazabilidad)] = mdl_INTERNO_ConfiguracionPantalla_Modelo;
                    }
                    else
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA.Add(nameof(P_AlbaranLinea_Trazabilidad), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                    }
                }
                else
                {
                    Variables.G_DCT_CONFIGURACIONPANTALLA = new Dictionary<string, INTERNO_ConfiguracionPantalla_Modelo>();
                    Variables.G_DCT_CONFIGURACIONPANTALLA.Add(nameof(P_AlbaranLinea_Trazabilidad), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                }

                //Actualizar el fichero XML
                Exferia_Aplicacion.General.Funciones_FicherosXML.ModificarXML_ConfiguracionPantallas(Variables.G_STR_CONFIGURACIONPANTALLA_TIPOPANTALLA_MANTENIMIENTO, nameof(P_AlbaranLinea_Trazabilidad), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                #endregion

            }
            catch (Control_Errores)
            { }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_AlbaranLinea_Trazabilidad) + "/" + nameof(P_AlbaranLinea_Trazabilidad_FormClosed));
            }
        }
        #endregion

        #region Centro de Informacion
        private void P_AlbaranLinea_Trazabilidad_SizeChanged(object sender, EventArgs e)
        {
            //calcular distancia del splitter
            spl_P_AlbaranLinea_Trazabilidad_Principal.SplitterDistance = spl_P_AlbaranLinea_Trazabilidad_Principal.Width - g_int_CentroInformacion_Ancho;
        }
        private void spl_P_AlbaranLinea_Trazabilidad_Principal_Panel2_SizeChanged(object sender, EventArgs e)
        {
            try
            {
                if (spl_P_AlbaranLinea_Trazabilidad_Principal.Panel2.Width > 0 &&
                    spl_P_AlbaranLinea_Trazabilidad_Principal.Panel2.Height > 0)
                {
                    ex_trv_P_AlbaranLinea_Trazabilidad_ArbolSecundarioSeleccion.Size = new Size(spl_P_AlbaranLinea_Trazabilidad_Principal.Panel2.Width - 2, spl_P_AlbaranLinea_Trazabilidad_Principal.Panel2.Height - 2);
                }

                g_int_CentroInformacion_Ancho = spl_P_AlbaranLinea_Trazabilidad_Principal.Width - spl_P_AlbaranLinea_Trazabilidad_Principal.SplitterDistance;
            }
            catch (Exception)
            { }
        }
        #endregion





    }
}
